require 'pry'

ENV['BIRDIE_DEBUG'] = 'true'

RSpec.configure do |config|
  config.order = "random"
end

class CollectionResponse
  attr_accessor :status, :collection, :headers

  def initialize(status, headers, body)
    self.status = status
    self.headers = headers
    self.collection = parse_body(body.first)
  end

  private

  def parse_body(body)
    deserializer = Conglomerate::TreeDeserializer.new(JSON.parse(body))
    deserializer.deserialize
  end
end

def call_action(action, params)
  raw_response = action.call(params)
  @collection_response = CollectionResponse.new(*raw_response)
end

def response
  @collection_response
end

def path_for(*args)
  Birdie::Application.app.router.path(*args)
end
